<template>
  <div>
    <el-card class="box-card">

      <div slot="header" class="clearfix">
        <h3>{{ isTuorialEdit ? 'Edit' : 'Add'}} Tutorial</h3>
      </div>

      <el-form ref="form" :model="form" label-width="120px">

        <el-form-item label="Tutorial Title">
          <el-input v-model="form.title" 
                    placeholder="Please input"></el-input>
        </el-form-item>

        <el-form-item label="Description">
          <el-input type="textarea" 
                    :rows="3" 
                    autosize 
                    v-model="form.description" 
                    placeholder="Please input"></el-input>
        </el-form-item>

        <el-form-item style="text-align:left;" v-if="isTuorialEdit" label="Status">
          <el-tag :type="form.status === 'pending' ? 'primary' : 'success'">{{form.status}}</el-tag>
        </el-form-item>

        <el-form-item v-if="isErrored">
          <el-alert
                  :title="errorMsg"
                  type="error"
                  show-icon>
        </el-alert>
        </el-form-item>

        <el-form-item v-if="isTuorialEdit">
          <el-button type="success" 
                    @click="onPublish">Publish</el-button>
          <el-button type="danger" 
                    @click="onDelete">Delete</el-button>
          <el-button type="primary" 
                    @click="onSubmit">Update</el-button>
        </el-form-item>

        <el-form-item v-else>
          <el-button type="primary" 
                    @click="onSubmit">Create</el-button>
          <el-button @click="onClear">Clear</el-button>
        </el-form-item>

      </el-form>
    </el-card>
  </div>
</template>

<script>
import { getTutorial, addTutorial, updateTutorial, deleteTutorial } from '../DataProvider/dataProvider.js'

export default {
  name: 'AddTutorial',
  props: {
    isEdit: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    isTuorialEdit () {
      if(!this.isEdit){
        this.onClear()
      }
      return this.isEdit
    }
  },
  data() {
    return {
      form: {
          title: '',
          description: '',
          status: ''
      },
      isErrored: false
    }
  },
  mounted(){
    if(this.isTuorialEdit){
      this.form = getTutorial(this.$route.params.id)
    }
    else{
      this.onClear()
    }
  },
  methods: {

    onSubmit() {
      if(!this.validate()) return
      if(this.isTuorialEdit){
        if(updateTutorial(this.form)){
          this.$notify({
            title: 'Tutorial Updated!',
            message: this.form?.title + ' Tutorial Updated successfully.',
            type: 'success'
          })
          this.$router.push('/tutorials')
        }
      }
      else{
        this.form.status = 'pending'
        if(addTutorial(this.form)){
          this.onClear()
          this.showNoty('Tutorial Added!', 'success', this.form?.title + ' Tutorial added successfully.', )
        }else{
          this.showError('Failed to Add Tutorial')
        }
      }
    },

    onPublish(){
      this.form.status = "published"
    },

    onDelete(){
      this.$confirm('This will permanently delete the Tutorial. Continue?', 'Warning', {
        confirmButtonText: 'Delete',
        cancelButtonText: 'Cancel',
        type: 'warning',
        center: true
      }).then(() => {
        if(deleteTutorial(this.form.id))
        {
          this.showMsg('success','Delete completed')
          this.$router.push('/tutorials')
        }else{
          this.showMsg('danger','Delete Failed')
        }
      }).catch(() => {
        this.showMsg('info','Delete canceled')
      })
    },

    showError(msg){
        this.errorMsg = msg
        this.isErrored = true
    },

    validate(){
      if(!this.form?.title) {
        this.showError('Tutorial Title is Empty')
        return false
      }
      if(!this.form?.description) {
        this.showError('Tutorial Description is Empty')
        return false
      }
      return true
    },

    onClear(){
      this.form = {
        title: '',
        description: '',
        status: ''
      }
      this.errorMsg = 'Error'
      this.isErrored = false
    }
  }
}
</script>
<style scoped>
  .box-card {
    width: 70%;
  }
  .input {
    margin-bottom: 18px;
  }
</style>

